#define XSIZE (240)
#define YSIZE (160)
typedef unsigned char byte;
extern byte* HMap;
extern byte* CMap;
extern byte* Video;
extern int lasty[XSIZE];
extern int lastc[XSIZE];

void FastIntDivide (int Numer, int Denom, int *Result, int *Remainder) __attribute__ ((section(".iwram")));

inline void FastIntDivide (int Numer, int Denom, int *Result, int *Remainder)
{
   asm volatile
      ("
      mov   r0,%2
      mov   r1,%3
      swi   0x60000

      ldr   r2,%0
      str   r0,[r2]
      ldr   r2,%1
      str   r1,[r2]
      "
      : "=m" (Result), "=m" (Remainder) // Outputs
      : "r" (Numer), "r" (Denom)        // Inputs
      : "r0","r1","r2","r3"             // Regs crushed & smushed
      );
}

void Line(int x0,int y0,int x1,int y1,int hy,int s)  __attribute__ ((section(".iwram")));
void Line(int x0,int y0,int x1,int y1,int hy,int s)
{
  int i,sx,sy;
  int junk;

  /* Compute xy speed */
  /* sx=(x1-x0)/XSIZE; sy=(y1-y0)/XSIZE; */
  FastIntDivide(x1-x0,XSIZE,&sx,&junk);
  FastIntDivide(y1-y0,XSIZE,&sy,&junk);
  
  for ( i=0; i<XSIZE; i++ )
  {
    int c,y,h,u0,v0,u1,v1,a,b,h0,h1,h2,h3;

    /* Compute the xy coordinates; a and b will be the position inside the
       single map cell (0..255).
     */
    u0=(x0>>16)&0xFF;    a=(x0>>8)&255;
    v0=((y0>>8)&0xFF00); b=(y0>>8)&255;
    u1=(u0+1)&0xFF;
    v1=(v0+256)&0xFF00;

    /* Fetch the height at the four corners of the square the point is in */
    h0=HMap[u0+v0]; h2=HMap[u0+v1];
    h1=HMap[u1+v0]; h3=HMap[u1+v1];

    /* Compute the height using bilinear interpolation */
    h0=(h0<<8)+a*(h1-h0);
    h2=(h2<<8)+a*(h3-h2);
    h=((h0<<8)+b*(h2-h0))>>16;

    /* Fetch the color at the four corners of the square the point is in */
    h0=CMap[u0+v0]; h2=CMap[u0+v1];
    h1=CMap[u1+v0]; h3=CMap[u1+v1];

    /* Compute the color using bilinear interpolation (in 16.16) */
    h0=(h0<<8)+a*(h1-h0);
    h2=(h2<<8)+a*(h3-h2);
    c=((h0<<8)+b*(h2-h0));

    /* Compute screen height using the scaling factor */
    y=(((h-hy)*s)>>11)+(YSIZE>>1);

    /* Draw the column */
    if ( y<(a=lasty[i]) )
    {
      unsigned char *b=Video+a*XSIZE+i;
      int sc,cc;


      if ( lastc[i]==-1 )
	lastc[i]=c;

      /* sc=(c-lastc[i])/(a-y); */
      FastIntDivide(c-lastc[i],a-y,&sc,&junk);
      
      cc=lastc[i];

      if ( a>(YSIZE-1) ) { b-=(a-(YSIZE-1))*XSIZE; cc+=(a-(YSIZE-1))*sc; a=(YSIZE-1); }
      if ( y<0 ) y=0;
      while ( y<a )
      {
	*b=cc>>18; cc+=sc;
	b-=XSIZE; a--;
      }
      lasty[i]=y;

    }
    lastc[i]=c;

    /* Advance to next xy position */
    x0+=sx; y0+=sy;
  }
}
